unit AdwareUtils;

interface

uses
  Classes, Types;

function GetNextField(var s : string) : string;
procedure ListFolder(folder : string; var list : TStringList);
function DeleteDir(Dir : string) : boolean;
procedure Delay (msec : DWORD);
function DecryptStr(strText, intPass : string) : string;

implementation

uses SysUtils, Windows, Forms;

function DeleteDir(Dir : string) : boolean;
var
  Found : integer;
  SearchRec : TSearchRec;
  s : string;
begin
  {$I-}
  result:=false;
  Found := FindFirst(Dir + '\*.*', faAnyFile, SearchRec);
  while Found = 0 do
  begin
    if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then
    begin
      s := dir + SearchRec.Name;
      if (SearchRec.Attr and faDirectory)<>0 then
      begin
        if not DeleteDir(s) then exit;
      end else
      if not SysUtils.DeleteFile(s) then
      begin
        exit;
      end;
    end;
    Found := FindNext(SearchRec);
  end;
  SysUtils.FindClose(SearchRec);
  SetCurrentDir(ExtractFilePath(Application.ExeName));
  result := RemoveDir(Dir);
end;

procedure ListFolder(folder : string; var list : TStringList);
var
  SearchRec : TSearchRec;
begin
  list.Clear();
  if FindFirst(folder + '\*.*', faAnyFile, SearchRec) = 0 then;
  repeat
    if (SearchRec.Name[1] <> '.') and (SearchRec.Attr and faDirectory = 0) then
    begin
      list.Add(SearchRec.Name);
    end;
  until FindNext(SearchRec) <> 0;
  SysUtils.FindClose(SearchRec);
end;

function GetNextField(var s : string) : string;
var
  p : word;
begin
  p := Pos('|', s);;
  if p > 0 then
  begin
    Result := Copy(s,1,p-1);
    Delete(s,1,p);                    //..and delete it from source string
  end else
    Result := s;
end;

procedure Delay (msec : DWORD);
var
  FirstTick : DWORD;
begin
  FirstTick:=GetTickCount;
  repeat
    Application.ProcessMessages;
  until (GetTickCount - FirstTick >= msec);
end;

function DecryptStr(strText, intPass : string) : string;
var
  t : integer;
  intTemp : byte;
  x1, g : integer;
  DeCrypted : string;
begin
  x1 := 0;
  DeCrypted := '';
  for t := 1 to Length(intPass) do
  begin
    intTemp := Ord(intPass[t]);
    x1 := x1 + intTemp;
  end;
  x1 := Trunc((x1 *0.1) /6);
  intPass := IntTostr(x1);
  g := 0;
  for t := 1 to Length(strText) do
  begin
    intTemp := Ord(strText[t]);
    inc(g);
    if g = 6 then g := 0;
    case g of
    0 : x1 := intTemp + (StrToInt(intPass)-2);
    1 : x1 := intTemp - (StrToInt(intPass)-5);
    2 : x1 := intTemp + (StrToInt(intPass)-4);
    3 : x1 := intTemp - (StrToInt(intPass)-2);
    4 : x1 := intTemp + (StrToInt(intPass)-3);
    5 : x1 := intTemp - (StrToInt(intPass)-5);
    end; // case
    x1 := x1 - g;
    DeCrypted := DeCrypted + Chr(x1);
  end;
  Result := DeCrypted;
end;

end.
