unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, StdCtrls, CoolTrayIcon, ComCtrls, Registry,
  CheckLst, ImgList, OleCtrls;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    btnStatus: TSpeedButton;
    btnScan: TSpeedButton;
    btnSettings: TSpeedButton;
    CoolTrayIcon: TCoolTrayIcon;
    imgListObjects: TImageList;
    dlgSaveReport: TSaveDialog;
    timerAutoScan: TTimer;
    TimerHomepage: TTimer;
    Notebook: TNotebook;
    Label1: TLabel;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel2: TBevel;
    Label7: TLabel;
    lMemory: TStaticText;
    lIP: TStaticText;
    lComp: TStaticText;
    lReg: TStaticText;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    btnShowIgnorList: TSpeedButton;
    Label13: TLabel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    lLastScan: TStaticText;
    lNumOfScans: TStaticText;
    lItemsRemoved: TStaticText;
    lIgnoreListCount: TStaticText;
    lDBVer: TStaticText;
    Label15: TLabel;
    Bevel3: TBevel;
    Notebook_Scan: TNotebook;
    btnSmartScan: TSpeedButton;
    Label16: TLabel;
    btnCustomScan: TSpeedButton;
    Label17: TLabel;
    Label14: TLabel;
    btnNext_S1: TBitBtn;
    gbOptions: TGroupBox;
    cbCookie: TCheckBox;
    cbProcess: TCheckBox;
    cbRegKey: TCheckBox;
    cbRegVal: TCheckBox;
    cbFolder: TCheckBox;
    cbFile: TCheckBox;
    Label20: TLabel;
    Bevel4: TBevel;
    lProgressProc: TLabel;
    lScanStatus: TLabel;
    btnStopScan: TSpeedButton;
    lCurOper: TStaticText;
    lScanItem: TStaticText;
    barProgress: TProgressBar;
    GroupBox2: TGroupBox;
    Label19: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Bevel5: TBevel;
    Label29: TLabel;
    Label21: TLabel;
    lTotProc: TStaticText;
    lIdentProc: TStaticText;
    lTotObjects: TStaticText;
    lObjIgnored: TStaticText;
    lTotFiles: TStaticText;
    lTotFolders: TStaticText;
    lTotKeys: TStaticText;
    lTotVals: TStaticText;
    lNewObjects: TStaticText;
    lTotCookie: TStaticText;
    panelInit: TPanel;
    Image1: TImage;
    Label18: TLabel;
    Label30: TLabel;
    btnFix: TSpeedButton;
    btnIgnor: TSpeedButton;
    btnInvert: TSpeedButton;
    listAdware: TListView;
    Label12: TLabel;
    btnSaveReport: TSpeedButton;
    memoReport: TMemo;
    barFixing: TProgressBar;
    Label32: TLabel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    cbInStartup: TCheckBox;
    cbStartMinimized: TCheckBox;
    cbFirstScan: TCheckBox;
    GroupBox3: TGroupBox;
    Label33: TLabel;
    btnActiveScanOn: TSpeedButton;
    btnActiveScanOff: TSpeedButton;
    comboScanInterval: TComboBox;
    cbAutoFix: TCheckBox;
    GroupBox4: TGroupBox;
    Label34: TLabel;
    btnHomePageOn: TSpeedButton;
    btnHomePageOff: TSpeedButton;
    eHomePage: TEdit;
    procedure ShowMemInfo;
    procedure FormCreate(Sender: TObject);
    procedure btnStatusClick(Sender: TObject);
    procedure btnScanClick(Sender: TObject);
    procedure CoolTrayIconClick(Sender: TObject);
    function LoadAdwareList(fname: string): boolean;
    procedure btnNext_S1Click(Sender: TObject);
    procedure AddItemToList(_type: integer; cat, obj, descr: string);
    procedure btnStopScanClick(Sender: TObject);
    procedure btnInvertClick(Sender: TObject);
    procedure btnFixClick(Sender: TObject);
    procedure SetRootKey(key: string);
    procedure AccesssInterface(enable: boolean);
    procedure btnSaveReportClick(Sender: TObject);
    procedure btnIgnorClick(Sender: TObject);
    function ReadIntRegValue(val: string): integer;
    function WriteIntRegValue(val: string; int: integer): integer;
    function ReadStringRegValue(val: string): string;
    function WriteStringRegValue(val: string; st: string): string;
    procedure btnSettingsClick(Sender: TObject);
    procedure btnSmartScanClick(Sender: TObject);
    procedure btnShowIgnorListClick(Sender: TObject);
    procedure cbFirstScanClick(Sender: TObject);
    procedure cbStartMinimizedClick(Sender: TObject);
    procedure cbInStartupClick(Sender: TObject);
    procedure btnActiveScanOnClick(Sender: TObject);
    procedure btnHomePageOnClick(Sender: TObject);
    procedure comboScanIntervalChange(Sender: TObject);
    procedure cbAutoFixClick(Sender: TObject);
    procedure eHomePageExit(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure timerAutoScanTimer(Sender: TObject);
    procedure TimerHomepageTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TAdwareIdent = object
    ident_type: byte;
    ident: string;
    soft_type: string;
  end;

  TAdware = object
    name: string;
    idents: array of TAdwareIdent;
  end;

const
  key = 22599;

  ID_COOKIE = 1;
  ID_REGVAL = 2;
  ID_REGKEY = 3;
  ID_FOLDER = 4;
  ID_FILE = 5;

  DBFile = 'DataBase.txt';
  HeaderPrefs = ['#', '@'];

var
  frmMain: TfrmMain;
  path_Windows, path_System: string;
  path_Desktop, path_Cookie: string;
  path_Start, path_Programs: string;
  path_Temp, path_AppData: string;
  AdwareDB, EncryptedDB, CookiesList: TStringList;
  AdwareList: array of TAdware;
  Registry: TRegistry;
  StopFlag: boolean = false;
  tot_ignored: longint = 0;
  NumOfScans, ItemsRemoved: longint;
  LastScan: string;
  tot_regkey, tot_regval, tot_cookie, tot_folder, tot_files, tot_proc: integer;
  JustStarted: boolean = true;
  NeedMinimize: boolean = false;
  ScanInProgress: boolean = false;
  NeedUpdate: boolean = false;
  ProcList: TstringList;

implementation

uses fSplash, AdwareUtils, StrUtils, fIgnoreList, ShellAPI, ShlObj, NetInfo,
  Tlhelp32;

{$R *.dfm}

function TfrmMain.LoadAdwareList(fname: string): boolean;
var
  line, idx, n: longint;
  st, field: string;
begin
  if FileExists(fname) then
  begin
    EncryptedDB.Clear();
    AdwareDB.Clear();
    AdwareDB.LoadFromFile('DataBase.txt');
    lDbVer.Caption := ' ' + AdwareDB.Strings[0];
    line := 1;
    idx := -1;
    if AdwareDB.Count = 0 then
      NeedUpdate := True;
    while line < AdwareDB.Count do
    begin
      st := AdwareDB.Strings[line];
      if Length(st) > 0 then
      begin
        if (st[1] in HeaderPrefs) then
        begin
          inc(idx);
          SetLength(AdwareList, idx + 1);
          AdwareList[idx].name := Copy(st, 2, Length(st) - 1);
          frmSplash.ShowStatus('Loading AdWare/SpyWare info: ' + AdwareList[idx].name);
        end
        else if idx > -1 then
        begin
          n := Length(AdwareList[idx].idents);
          SetLength(AdwareList[idx].idents, n + 1);
          field := UpperCase(GetNextField(st));
          if field = 'COOKIE' then
            AdwareList[idx].idents[n].ident_type := ID_COOKIE;
          if field = 'REGKEY' then
            AdwareList[idx].idents[n].ident_type := ID_REGKEY;
          if field = 'REGVAL' then
            AdwareList[idx].idents[n].ident_type := ID_REGVAL;
          if field = 'FOLDER' then
            AdwareList[idx].idents[n].ident_type := ID_FOLDER;
          if field = 'PATH' then
            AdwareList[idx].idents[n].ident_type := ID_FILE;

          field := GetNextField(st);
          if Length(field) > 0 then
          begin
            if field[1] = '&' then
              field[1] := '%';
            if Pos('%', field) <> 0 then
            begin
              field := AnsiReplaceStr(field, '%WinDir%', path_Windows);
              field := AnsiReplaceStr(field, '%WinsDir%', path_Windows);
              field := AnsiReplaceStr(field, '%SystemDir%', path_System);
              field := AnsiReplaceStr(field, '%SystemFolder%', path_System);
              field := AnsiReplaceStr(field, '%SystemsDir%', path_System);
              field := AnsiReplaceStr(field, '%ProgramsDir%', path_Programs);
              field := AnsiReplaceStr(field, '%WProgramsDir%', path_Programs);
              field := AnsiReplaceStr(field, '%TempDir%', path_Temp);
              field := AnsiReplaceStr(field, '%TempDir', path_Temp);
              field := AnsiReplaceStr(field, '%AppData%', path_AppData);
              field := AnsiReplaceStr(field, '%Desktop%', path_Desktop);
              field := AnsiReplaceStr(field, '%WDesktop%', path_Desktop);
              field := AnsiReplaceStr(field, '%StartMenu%', path_Start);
              field := AnsiReplaceStr(field, '%startMenu%', path_Start);
            end;
            AdwareList[idx].idents[n].ident := field;
          end;
          AdwareList[idx].idents[n].soft_type := GetNextField(st);
        end;
      end;
      inc(line);
    end;
    Result := True;
  end
  else
  begin
    Result := False;
    NeedUpdate := True;
  end;
end;

procedure TfrmMain.ShowMemInfo;
var
  MemTotal, MemFree: Integer;
  MemoryStatus: TMemoryStatus;
begin
  if NeedMinimize then
  begin
    NeedMinimize := false;
    CoolTrayIcon.HideMainForm();
  end;
  MemoryStatus.dwLength := SizeOf(MemoryStatus);
  GlobalMemoryStatus(MemoryStatus);
  MemTotal := MemoryStatus.dwTotalPhys div 1024 div 1024;
  MemFree := MemoryStatus.dwAvailPhys div 1042 div 1024;
  if MemTotal <> 0 then
    lMemory.Caption := ' Total: ' + IntToStr(MemTotal) +
      ' MB; Free: ' + IntToStr(MemFree) + ' MB (' +
      IntToStr((MemFree * 100) div MemTotal) + '%)';
end;

function GetSpecialFolder(const CSIDL: integer): string;
var
  RecPath: PAnsiChar;
begin
  RecPath := StrAlloc(MAX_PATH);
  try
    FillChar(RecPath^, MAX_PATH, 0);
    if SHGetSpecialFolderPath(0, RecPath, CSIDL, false) then
      Result := RecPath
    else
      Result := '';
  finally
    StrDispose(RecPath);
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  path, ip: string;
begin
  Registry := TRegistry.Create(KEY_ALL_ACCESS);
  AdwareDB := TStringList.Create();
  EncryptedDB := TStringList.Create();
  IgnoreList := TStringList.Create();
  CookiesList := TStringList.Create();
  ProcList := TStringList.Create();
  path := ExtractFilePath(Application.ExeName);
  if FileExists(path + '\' + IgnoreListFile) then
    IgnoreList.LoadFromFile(path + '\' + IgnoreListFile);
  frmSplash.ShowStatus('Readig system settings...');
  Notebook.PageIndex := 0;
  Application.ProcessMessages();

  GetLocalIP(ip);
  lIP.Caption := ' IP: ' + IP + ' MAC: ' + GetMACAddress();
  lComp.Caption := ' ' + GetComputerName();
  lReg.Caption := ' ' + GetUserFromWindows;
  lIgnoreListCount.Caption := IntToStr(IgnoreList.Count) + ' ';
  //---------- Read Settings from registry --------------
  LastScan := ReadStringRegValue('LastScan');
  if LastScan = '' then
    lLastScan.Caption := ' Never.'
  else
    lLastScan.Caption := ' ' + LastScan;
  LoadAdwareList(ExtractFilePath(Application.ExeName) + '\' + DBFile);
  ItemsRemoved := ReadIntRegValue('ItemsRemoved');
  lItemsRemoved.Caption := IntToStr(ItemsRemoved) + ' ';
  NumOfScans := ReadIntRegValue('NumOfScans');
  lNumOfScans.Caption := IntToStr(NumOfScans) + ' ';
  cbInStartup.Checked := (ReadIntRegValue('InStartUp') = 1);
  cbStartMinimized.Checked := (ReadIntRegValue('StartMinimized') = 1);
  cbFirstScan.Checked := (ReadIntRegValue('FirstScan') = 1);
  cbAutoFix.Checked := (ReadIntRegValue('AutoFix') = 1);
  comboScanInterval.ItemIndex := ReadIntRegValue('ScanInterval');
  btnActiveScanOn.Down := (ReadIntRegValue('AutoScan') = 1);
  eHomepage.Text := ReadStringRegValue('HomePage');
  btnHomepageOn.Down := (ReadIntRegValue('HomepageProtect') = 1);
  timerAutoScan.Enabled := btnActiveScanOn.Down;
  case comboScanInterval.ItemIndex of
    0: timerAutoScan.Interval := 5 * 60 * 1000;
    1: timerAutoScan.Interval := 10 * 60 * 1000;
    2: timerAutoScan.Interval := 15 * 60 * 1000;
    3: timerAutoScan.Interval := 20 * 60 * 1000;
    4: timerAutoScan.Interval := 30 * 60 * 1000;
    5: timerAutoScan.Interval := 60 * 60 * 1000;
  end;              //case
  //Browser.Navigate(path + '\help.htm');
  //---------- Read System Folders ----------------------
  frmSplash.ShowStatus('Reading software configuration...');
  path_Windows := GetSpecialFolder($0024); //CSIDL_WINDOWS (0x0024)
  path_System := GetSpecialFolder($0025); //CSIDL_SYSTEM (0x0025)
  path_Desktop := GetSpecialFolder($0019); //CSIDL_COMMON_DESKTOPDIRECTORY (0x0019)
  path_Cookie := GetSpecialFolder($0021); //CSIDL_COOKIES (0x0021)
  path_Start := GetSpecialFolder($0016); //CSIDL_COMMON_STARTMENU (0x0016)
  path_Temp := GetSpecialFolder($0020); //CSIDL_INTERNET_CACHE (0x0020)
  path_AppData := GetSpecialFolder($001A); //CSIDL_APPDATA (0x001A)
  try
    Registry.RootKey := HKEY_LOCAL_MACHINE;
    Registry.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion', False);
    path_Programs := Registry.ReadString('ProgramFilesDir');
  finally
    //Registry.Free;
  end;
  frmSplash.ShowStatus('Reading AdWare/SpyWare Database...');
  LoadAdwareList(ExtractFilePath(Application.ExeName) + '\' + DBFile);
  ShowMemInfo();
end;

procedure TfrmMain.btnStatusClick(Sender: TObject);
begin
  lIgnoreListCount.Caption := IntToStr(IgnoreList.Count) + ' ';
  Notebook.PageIndex := 0;
end;

procedure TfrmMain.btnScanClick(Sender: TObject);
begin
  NoteBook_Scan.PageIndex := 0;
  Notebook.PageIndex := 1;
end;

procedure TfrmMain.AddItemToList(_type: integer; cat, obj, descr: string);
var
  item: TListItem;
  i: longint;
begin
  for i := 0 to IgnoreList.Count - 1 do
  begin
    if UpperCase(IgnoreList.Strings[i]) = UpperCase(obj) then
    begin
      inc(tot_ignored);
      exit;
    end;
  end;
  item := listAdware.Items.Add;
  case _type of
    ID_COOKIE: item.Caption := 'Cookie';
    ID_REGVAL: item.Caption := 'Value';
    ID_REGKEY: item.Caption := 'Key';
    ID_FOLDER: item.Caption := 'Folder';
    ID_FILE: item.Caption := 'File';
  end;              // case _type
  item.Checked := true;
  item.ImageIndex := _type;
  item.SubItems.Add(cat);
  item.SubItems.Add(descr);
  item.SubItems.Add(obj);
end;

procedure TfrmMain.CoolTrayIconClick(Sender: TObject);
begin
  CoolTrayIcon.ShowMainForm();
  Application.Restore();
  Application.BringToFront();
end;

procedure TfrmMain.SetRootKey(key: string);
begin
  if key = 'HKEY_CURRENT_USER' then
    Registry.RootKey := HKEY_CURRENT_USER;
  if key = 'HKEY_LOCAL_MACHINE' then
    Registry.RootKey := HKEY_LOCAL_MACHINE;
  if key = 'HKEY_CLASSES_ROOT' then
    Registry.RootKey := HKEY_CLASSES_ROOT;
end;

function TfrmMain.ReadIntRegValue(val: string): integer;
begin
  Result := 0;
  Registry.RootKey := HKEY_CURRENT_USER;
  if Registry.OpenKey('\Software\SpyDie', true) then
    if Registry.ValueExists(val) then
      Result := Registry.ReadInteger(val);
end;

function TfrmMain.WriteIntRegValue(val: string; int: integer): integer;
begin
  Result := int;
  Registry.RootKey := HKEY_CURRENT_USER;
  Registry.OpenKey('\Software\SpyDie', true);
  Registry.WriteInteger(val, int);
end;

function TfrmMain.ReadStringRegValue(val: string): string;
begin
  Result := '';
  Registry.RootKey := HKEY_CURRENT_USER;
  if Registry.OpenKey('\Software\SpyDie', true) then
    if Registry.ValueExists(val) then
      Result := Registry.ReadString(val);
end;

function TfrmMain.WriteStringRegValue(val: string; st: string): string;
begin
  Result := st;
  Registry.RootKey := HKEY_CURRENT_USER;
  Registry.OpenKey('\Software\SpyDie', true);
  Registry.WriteString(val, st);
end;

procedure TfrmMain.AccesssInterface(enable: boolean);
begin
  btnStatus.Enabled := enable;
  btnScan.Enabled := enable;
  btnSettings.Enabled := enable;
end;

procedure GetProcessList(var list: TstringList);
var
  handler: THandle;
  data: TProcessEntry32;

  function GetName: string;
  var
    i: byte;
  begin
    Result := '';
    i := 0;
    while data.szExeFile[i] <> '' do
    begin
      Result := Result + data.szExeFile[i];
      Inc(i);
    end;
  end;

begin
  handler := CreateToolhelp32Snapshot(TH32CS_SNAPALL, 0);
  list.Clear();
  if Process32First(handler, data) then
  begin
    list.Add(GetName());
    while Process32Next(handler, data) do
      list.Add(GetName());
  end;
end;

procedure TfrmMain.btnNext_S1Click(Sender: TObject);
var
  i, j, k, p, p1, len: longint;
  root_key, key, key_val: string;
  list: TStringList;

  procedure ShowStat;
  var
    total: longint;
  begin
    total := tot_cookie + tot_folder + tot_files + tot_regval + tot_regkey;
    lTotCookie.Caption := IntToStr(tot_cookie) + ' ';
    lTotFolders.Caption := IntToStr(tot_folder) + ' ';
    lTotFiles.Caption := IntToStr(tot_files) + ' ';
    lTotVals.Caption := IntToStr(tot_regval) + ' ';
    lTotKeys.Caption := IntToStr(tot_regkey) + ' ';
    lIdentProc.Caption := IntToStr(tot_proc) + ' ';
    lTotObjects.Caption := IntToStr(total) + ' ';
    lObjIgnored.Caption := IntToStr(tot_ignored) + ' ';
    lNewObjects.Caption := IntToStr(total - tot_ignored) + ' ';
  end;

begin
  Notebook_Scan.PageIndex := 1;
  CoolTrayIcon.CycleIcons := true;
  tot_regkey := 0;
  tot_regval := 0;
  tot_cookie := 0;
  tot_folder := 0;
  tot_files := 0;
  tot_proc := 0;
  tot_ignored := 0;
  try               //<---------- Start of protected section
    ShowStat();
    listAdware.Items.Clear();
    AccesssInterface(false);
    list := TStringList.Create;
    lScanStatus.Caption := '';
    lProgressProc.Caption := 'Progress: (0%)';
    barProgress.Position := 0;
    lCurOper.Caption := '!!! PLEASE WAIT !!!';
    if (btnCustomScan.Down and (cbProcess.Checked))
      or (not btnCustomScan.Down) then
    begin
      lScanItem.Caption := ' Checking active processes...';
      Screen.Cursor := crHourGlass;
      panelInit.Visible := true;
      Application.ProcessMessages();
      GetProcessList(ProcList);
      lTotProc.Caption := IntToStr(ProcList.Count) + ' ';
    end
    else
      lTotProc.Caption := 'N/A ';
    panelInit.Visible := False;
    Application.ProcessMessages();
    Screen.Cursor := crDefault;
    lCurOper.Caption := 'Listing cookies...';
    ListFolder(path_Cookie, CookiesList);
    barProgress.Max := Length(AdwareList);
    Application.ProcessMessages();
    for i := 0 to Length(AdwareList) - 1 do
    begin
      lProgressProc.Caption := 'Progress: (' +
        IntToStr(((i + 1) * 100) div Length(AdwareList)) + '%)';
      barProgress.Position := i + 1;
      lCurOper.Caption := 'Scanning for AdWare/SpyWare: ' + AdwareList[i].name;
      for j := 0 to Length(AdwareList[i].idents) - 1 do
      begin
        case AdwareList[i].idents[j].ident_type of
          ID_COOKIE:
            begin
              if btnCustomScan.Down and (not cbCookie.Checked) then
                continue;
              lScanItem.Caption := ' Cookies: ' + AdwareList[i].idents[j].ident;
              for k := 0 to CookiesList.Count - 1 do
              begin
                if StopFlag then
                  Break;
                if Pos(UpperCase(AdwareList[i].idents[j].ident),
                  UpperCase(CookiesList.Strings[k])) <> 0 then
                begin
                  inc(tot_cookie);
                  AddItemToList(AdwareList[i].idents[j].ident_type,
                    AdwareList[i].name,
                    CookiesList.Strings[k],
                    AdwareList[i].idents[j].soft_type);
                end;
              end;
            end;    //COOKIE
          ID_FOLDER:
            begin
              if btnCustomScan.Down and (not cbFolder.Checked) then
                continue;
              lScanItem.Caption := ' Folder: ' + AdwareList[i].idents[j].ident;
              if DirectoryExists(AdwareList[i].idents[j].ident) then
              begin
                inc(tot_folder);
                AddItemToList(AdwareList[i].idents[j].ident_type,
                  AdwareList[i].name,
                  AdwareList[i].idents[j].ident,
                  AdwareList[i].idents[j].soft_type);
              end;
            end;    //FOLDER
          ID_FILE:
            begin
              if btnCustomScan.Down and (not cbFile.Checked) then
                continue;
              lScanItem.Caption := ' File: ' + AdwareList[i].idents[j].ident;
              if FileExists(AdwareList[i].idents[j].ident) then
              begin
                inc(tot_files);
                for k := 0 to ProcList.Count - 1 do
                begin
                  key := UpperCase(ExtractFileName(AdwareList[i].idents[j].ident));
                  key := Copy(key, 1, Pos('.', key) - 1);
                  p := Pos(key, UpperCase(ProcList[k]));
                  if p > 0 then
                    Inc(tot_proc);
                end;
                AddItemToList(AdwareList[i].idents[j].ident_type,
                  AdwareList[i].name,
                  AdwareList[i].idents[j].ident,
                  AdwareList[i].idents[j].soft_type);
              end;
            end;    //FILE
          ID_REGKEY:
            begin
              if btnCustomScan.Down and (not cbRegKey.Checked) then
                continue;
              lScanItem.Caption := ' Registry Key: ' + AdwareList[i].idents[j].ident;
              p := Pos('\', AdwareList[i].idents[j].ident);
              root_key := Copy(AdwareList[i].idents[j].ident, 1, p - 1);
              SetRootKey(root_key);
              key := Copy(AdwareList[i].idents[j].ident, p + 1,
                Length(AdwareList[i].idents[j].ident));
              if Registry.KeyExists(key) then
              begin
                inc(tot_regkey);
                AddItemToList(AdwareList[i].idents[j].ident_type,
                  AdwareList[i].name,
                  AdwareList[i].idents[j].ident,
                  AdwareList[i].idents[j].soft_type);
              end;
            end;    //REGKEY
          ID_REGVAL:
            begin
              if btnCustomScan.Down and (not cbRegVal.Checked) then
                continue;
              lScanItem.Caption := ' Registry Value: ' + AdwareList[i].idents[j].ident;
              len := Length(AdwareList[i].idents[j].ident);
              p := Pos('\', AdwareList[i].idents[j].ident);
              root_key := Copy(AdwareList[i].idents[j].ident, 1, p - 1);
              p1 := Pos(',', AdwareList[i].idents[j].ident);
              key := Copy(AdwareList[i].idents[j].ident, p + 1, p1 - p - 1);
              key_val := Copy(AdwareList[i].idents[j].ident, p1 + 1, len);
              SetRootKey(root_key);
              Registry.OpenKey(key, false);
              Registry.GetValueNames(list);
              for k := 0 to list.Count - 1 do
              begin
                if Pos(UpperCase(key_val), UpperCase(list.Strings[k])) > 0 then
                begin
                  inc(tot_regval);
                  AddItemToList(AdwareList[i].idents[j].ident_type,
                    AdwareList[i].name,
                    AdwareList[i].idents[j].ident,
                    AdwareList[i].idents[j].soft_type);
                end;
              end;
            end;    //REGVAL
        end;        //case of ident_type
        ShowStat;
        Application.ProcessMessages();
        if StopFlag then
          Break
      end;          //For j (idents);
      lScanStatus.Caption := IntToStr(i + 1) + ' of ' +
        IntToStr(barProgress.Max) + ' scanned.';
      Application.ProcessMessages();
      if StopFlag then
        Break
    end;            //For i (AdwareList)
    WriteStringRegValue('LastScan', DateTimeToStr(Now()));
    lLastScan.Caption := ' ' + DateTimeToStr(Now());
    inc(NumOfScans);
    WriteIntRegValue('NumOfScans', NumOfScans);
    lNumOfScans.Caption := IntToStr(NumOfScans) + ' ';
  finally
    lCurOper.Caption := 'Finished.';
    lScanItem.Caption := ' Done.';
    if listAdware.Items.Count = 0 then
    begin
      MessageDlg('SpyDie did''t find any Adware or Spyware on your computer!',
        mtInformation, [mbOk], 0);
      Notebook_Scan.PageIndex := 0;
    end
    else
    begin
      Notebook_Scan.PageIndex := 2;
    end;
    CoolTrayIcon.CycleIcons := false;
    CoolTrayIcon.IconIndex := 0;
    AccesssInterface(true);
    StopFlag := false;
    Screen.Cursor := crDefault;
  end;              //<---------- End of protected section
end;

procedure TfrmMain.btnStopScanClick(Sender: TObject);
begin
  StopFlag := True;
end;

procedure TfrmMain.btnInvertClick(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to listAdware.Items.Count - 1 do
    listAdware.Items[i].Checked := not listAdware.Items[i].Checked;
end;

function FindPID(ExeFileName: string): integer;
const
  PROCESS_TERMINATE = $0001;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  result := 0;
  FSnapshotHandle := CreateToolhelp32Snapshot
    (TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle,
    FProcessEntry32);
  while integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
      UpperCase(ExeFileName))
      or (UpperCase(FProcessEntry32.szExeFile) =
      UpperCase(ExeFileName))) then
      Result :=
        FProcessEntry32.th32ProcessID;
        ContinueLoop := Process32Next(FSnapshotHandle,
        FProcessEntry32);
  end;
  CloseHandle(FSnapshotHandle);
end;

procedure TfrmMain.btnFixClick(Sender: TObject);
const
  PROCESS_MURDER = $0001;
var
  i, k: integer;
  p, p1, len: integer;
  root_key, key, key_val: string;
  ProcessHandle: THandle;
  tot_regkey, tot_regval, tot_cookie, tot_folder, tot_files, tot_proc: integer;
begin
  ScanInProgress := true;
  tot_regkey := 0;
  tot_regval := 0;
  tot_cookie := 0;
  tot_folder := 0;
  tot_files := 0;
  tot_proc := 0;
  notebook_Scan.PageIndex := 3;
  AccesssInterface(false);
  memoReport.Lines.Clear();
  memoReport.Lines.Add('Adware Fixing Report');
  memoReport.Lines.Add(DateTimeToStr(Now()));
  memoReport.Lines.Add('---------------------------------');
  BarFixing.Max := listAdware.Items.Count * 2;
  try               //<---------- Start of protected section
    //---------- Kill Processes and Delete files ----------
    for i := 0 to (listAdware.Items.Count - 1) do
    begin
      BarFixing.Position := i;
      if listAdware.Items[i].Checked then
      begin
        if listAdware.Items[i].ImageIndex = ID_FILE then
        begin

          for k := 0 to ProcList.Count - 1 do
          begin
            key := UpperCase(ExtractFileName(listAdware.Items[i].SubItems[2]));
            p := Pos(key, UpperCase(ProcList[k]));
            if p > 0 then
            begin
              ProcessHandle := OpenProcess(PROCESS_MURDER, FALSE, FindPID(ProcList[k]));
              if TerminateProcess(ProcessHandle, 4) = true then
              begin
                memoReport.Lines.Add('[+] AdWare/SpyWare Process Terminanted: ' +
                  listAdware.Items[i].SubItems[2]);
                inc(tot_proc);
              end
              else
                memoReport.Lines.Add('[!] Can''t Terminante Process: ' +
                  listAdware.Items[i].SubItems[2]);
            end;    // if process found
          end;      // for (list processes)

          Delay(1000);
          if DeleteFile(listAdware.Items[i].SubItems[2]) then
          begin
            memoReport.Lines.Add('[+] AdWare/SpyWare Deleted: ' +
              listAdware.Items[i].SubItems[2]);
            inc(tot_files);
          end
          else
            memoReport.Lines.Add('[!] Can''t Delete AdWare/SpyWare: ' +
              listAdware.Items[i].SubItems[2]);
        end;        // if this is file
      end;          // if need to delete this
    end;            // for i
    for i := 0 to listAdware.Items.Count - 1 do
    begin
      BarFixing.Position := listAdware.Items.Count * i;
      if listAdware.Items[i].Checked then
      begin
        len := Length(listAdware.Items[i].SubItems[2]);
        case listAdware.Items[i].ImageIndex of
          ID_COOKIE:
            begin
              if DeleteFile(path_Cookie + '\' + listAdware.Items[i].SubItems[2]) then
              begin
                memoReport.Lines.Add('[+] AdWare/SpyWare Cookies Deleted: ' +
                  listAdware.Items[i].SubItems[2]);
                inc(tot_cookie);
              end
              else
                memoReport.Lines.Add('[!] Can''t Delete Cookie: ' +
                  listAdware.Items[i].SubItems[2])

            end;
          ID_REGVAL:
            begin
              p := Pos('\', listAdware.Items[i].SubItems[2]);
              root_key := Copy(listAdware.Items[i].SubItems[2], 1, p - 1);
              p1 := Pos(',', listAdware.Items[i].SubItems[2]);
              key := Copy(listAdware.Items[i].SubItems[2], p + 1, p1 - p - 1);
              key_val := Copy(listAdware.Items[i].SubItems[2], p1 + 1, len);
              SetRootKey(root_key);
              Registry.OpenKey(key, false);
              if Registry.DeleteValue(key_val) then
              begin
                memoReport.Lines.Add('[+] Registry Value Deleted: ' +
                  listAdware.Items[i].SubItems[2]);
                inc(tot_regval);
              end
              else
                memoReport.Lines.Add('[!] Can''t Delete Value: ' +
                  listAdware.Items[i].SubItems[2])
            end;
          ID_REGKEY:
            begin
              p := Pos('\', listAdware.Items[i].SubItems[2]);
              root_key := Copy(listAdware.Items[i].SubItems[2], 1, p - 1);
              SetRootKey(root_key);
              key := Copy(listAdware.Items[i].SubItems[2], p + 1, len);
              if Registry.DeleteKey(key) then
              begin
                memoReport.Lines.Add('[+] Registry Key Deleted: ' +
                  listAdware.Items[i].SubItems[2]);
                inc(tot_regkey);
              end
              else
                memoReport.Lines.Add('[!] Can''t Delete Key: ' +
                  listAdware.Items[i].SubItems[2])
            end;
          ID_FOLDER:
            begin
              listAdware.Items[i].ImageIndex := 6;
              if DeleteDir(listAdware.Items[i].SubItems[2]) then
              begin
                memoReport.Lines.Add('[+] Folder Deleted: ' +
                  listAdware.Items[i].SubItems[2]);
                inc(tot_folder);
              end
              else
                memoReport.Lines.Add('[!] Can''t Delete Folder: ' +
                  listAdware.Items[i].SubItems[2])

            end;
        end;        // case
      end;          //if checked
      Application.ProcessMessages;
    end;            //for
    //---- save stat to registry
    ItemsRemoved := ItemsRemoved + tot_files + tot_folder + tot_cookie +
      tot_regkey + tot_regval;
    WriteIntRegValue('ItemsRemoved', ItemsRemoved);
    lItemsRemoved.Caption := IntToStr(ItemsRemoved) + ' ';
    //----- report footer
  finally
    memoReport.Lines.Add('---------------------------------');
    memoReport.Lines.Add('Total Processes stoped: ' + IntToStr(tot_proc));
    memoReport.Lines.Add('Total Files Deleted: ' + IntToStr(tot_files));
    memoReport.Lines.Add('Total Folders Deleted: ' + IntToStr(tot_folder));
    memoReport.Lines.Add('Total AdWare/SpyWare Cookies Deleted: ' + IntToStr(tot_cookie));
    memoReport.Lines.Add('Total Registry Keys Deleted: ' + IntToStr(tot_regkey));
    memoReport.Lines.Add('Total Registry Valies Deleted: ' + IntToStr(tot_regval));
    memoReport.Lines.Add('------------- E N D -------------');
    ScanInProgress := false;
    AccesssInterface(true);
  end;              //<---------- End of protected section
end;

procedure TfrmMain.btnSaveReportClick(Sender: TObject);
begin
  dlgSaveReport.InitialDir := ExtractFilePath(Application.ExeName);
  if dlgSaveReport.Execute then
  begin
    memoReport.Lines.SaveToFile(dlgSaveReport.FileName);
  end;
end;

procedure TfrmMain.btnIgnorClick(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to (listAdware.Items.Count - 1) do
  begin
    if listAdware.Items[i].Checked then
      IgnoreList.Add(listAdware.Items[i].SubItems[2]);
  end;
  IgnoreList.SaveToFile(ExtractFilePath(Application.ExeName) +
    '\' + IgnoreListFile);
  MessageDlg('Ignore List was successfuly saved.', mtInformation, [mbOk], 10);
end;

procedure TfrmMain.btnSettingsClick(Sender: TObject);
begin
  Notebook.PageIndex := 2;
end;

procedure TfrmMain.btnSmartScanClick(Sender: TObject);
begin
  cbCookie.Enabled := btnCustomScan.Down;
  cbProcess.Enabled := btnCustomScan.Down;
  cbRegval.Enabled := btnCustomScan.Down;
  cbRegKey.Enabled := btnCustomScan.Down;
  cbFile.Enabled := btnCustomScan.Down;
  cbFolder.Enabled := btnCustomScan.Down;
end;

procedure TfrmMain.btnShowIgnorListClick(Sender: TObject);
begin
  frmIgnoreList.Show();
end;

procedure TfrmMain.cbFirstScanClick(Sender: TObject);
begin
  if cbFirstScan.Checked then
    WriteIntRegValue('FirstScan', 1)
  else
    WriteIntRegValue('FirstScan', 0);
end;

procedure TfrmMain.cbStartMinimizedClick(Sender: TObject);
begin
  if cbStartMinimized.Checked then
    WriteIntRegValue('StartMinimized', 1)
  else
    WriteIntRegValue('StartMinimized', 0);
end;

procedure TfrmMain.cbInStartupClick(Sender: TObject);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create();
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if cbInStartup.Checked then
    begin
      Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', false);
      Reg.WriteString('NetSpyProtect', Application.ExeName);
      WriteIntRegValue('inStartup', 1)
    end
    else
    begin
      Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', false);
      Reg.DeleteValue('NetSpyProtect');
      WriteIntRegValue('inStartup', 0);
    end;
  finally
    Reg.Free();
  end;
end;

procedure TfrmMain.btnActiveScanOnClick(Sender: TObject);
begin
  if btnActiveScanOn.Down then
  begin
    WriteIntRegValue('AutoScan', 1);
    timerAutoscan.Enabled := true;
  end
  else
  begin
    timerAutoscan.Enabled := false;
    WriteIntRegValue('AutoScan', 0);
  end;
end;

procedure TfrmMain.btnHomePageOnClick(Sender: TObject);
begin
  if btnHomepageOn.Down then
    WriteIntRegValue('HomepageProtect', 1)
  else
    WriteIntRegValue('HomepageProtect', 0);
end;

procedure TfrmMain.comboScanIntervalChange(Sender: TObject);
begin
  WriteIntRegValue('ScanInterval', comboScanInterval.ItemIndex);
  case comboScanInterval.ItemIndex of
    0: timerAutoScan.Interval := 5 * 60 * 1000;
    1: timerAutoScan.Interval := 10 * 60 * 1000;
    2: timerAutoScan.Interval := 15 * 60 * 1000;
    3: timerAutoScan.Interval := 20 * 60 * 1000;
    4: timerAutoScan.Interval := 30 * 60 * 1000;
    5: timerAutoScan.Interval := 60 * 60 * 1000;
  end;              //case
end;

procedure TfrmMain.cbAutoFixClick(Sender: TObject);
begin
  if cbAutofix.Checked then
    WriteIntRegValue('AutoFix', 1)
  else
    WriteIntRegValue('AutoFix', 0);
end;

procedure TfrmMain.eHomePageExit(Sender: TObject);
begin
  WriteStringRegValue('HomePage', eHomePage.Text);
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  if JustStarted then
  begin
    frmSplash.Close();
    JustStarted := false;
    if cbStartMinimized.Checked then
    begin
      NeedMinimize := true;
    end;
    if cbFirstScan.Checked then
    begin
      Notebook.PageIndex := 1;
      Delay(100);
      btnNext_S1.Click();
    end;
  end;
end;

procedure TfrmMain.timerAutoScanTimer(Sender: TObject);
var
  s: string;
begin
  timerAutoScan.Enabled := false;
  try
    ShowMemInfo();
    if not ScanInProgress then
    begin
      btnNext_S1.Click();
      repeat
        Application.ProcessMessages();
      until Notebook_Scan.PageIndex = 2;
      if cbAutoFix.Checked then
      begin
        Notebook.PageIndex := 1;
        Delay(100);
        btnFix.Click();
      end
      else
      begin
        s := '';
        if tot_regkey > 0 then
          s := s + 'Registry Keys: ' + IntToStr(tot_regkey) + #13;
        if tot_regval > 0 then
          s := s + 'Registry Values: ' + IntToStr(tot_regval) + #13;
        if tot_cookie > 0 then
          s := s + 'AdWare/SpyWare Cookies: ' + IntToStr(tot_cookie) + #13;
        if tot_folder > 0 then
          s := s + 'AdWare/SpyWare Folders: ' + IntToStr(tot_folder) + #13;
        if tot_files > 0 then
          s := s + 'AdWare/SpyWare Files: ' + IntToStr(tot_files) + #13;
        if tot_proc > 0 then
          s := s + 'Active Adware: ' + IntToStr(tot_proc) + #13;
        if s <> '' then
        begin
          s[Length(s)] := #32;
          CoolTrayIcon.ShowBalloonHint('SpyDie Scan Results:', s, bitInfo, 10);
        end;
      end;
    end;
  finally
    timerAutoScan.Enabled := true;
  end;
end;

procedure TfrmMain.TimerHomepageTimer(Sender: TObject);
var
  Reg: TRegistry;
begin
  if btnHomePageOn.Down then
  begin
    Reg := TRegistry.Create();
    try
      Reg.RootKey := HKEY_CURRENT_USER;
      Reg.OpenKey('\Software\Microsoft\Internet Explorer\Main', false);
      Reg.WriteString('Start Page', eHomePage.Text);
    finally
      Reg.Free();
    end;
  end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  Registry.Free();
  AdwareDB.Free();
  EncryptedDB.Free();
  IgnoreList.Free();
  CookiesList.Free();
  ProcList.Free();
end;

end.

